%define name	sympa
%define version	3.0.3
%define release	1mdk
%define home_s	/var/lib/sympa
%define home_a	/var/www

Summary:	SYMPA is an electronic mailing list manager
Summary(fr):	SYMPA est un gestionnaire de listes lectroniques
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Servers
Source:		http://listes.cru.fr/sympa/distribution/%{name}-%{version}.tar.bz2
# (gb) added correctly exported vars (PIDDIR, SPOOLDIR) while subst-creating /etc/[ww]sympa.conf
Patch0:		%{name}-3.0.3-var-subst.patch.bz2
URL:		http://listes.cru.fr/sympa/
Requires:	perl               >= 5.00403
Requires:	perl-MailTools     >= 1.14
Requires:	perl-MIME-Base64   >= 1.0
Requires:	perl-IO-stringy    >= 1.0
Requires:	perl-Msgcat        >= 1.03
Requires:	perl-MIME-tools    >= 5.209
Requires:	perl-CGI           >= 2.52
Requires:	perl-DBI           >= 1.06
Requires:	perl-DB_File       >= 1.0
## Also requires a DBD for the DBMS 
## (perl-DBD-Pg or Perl-Msql-Mysql-modules)
Requires:	perl-perl-ldap     >= 0.10
Requires:	perl-FCGI          >= 0.48
# (gb) not required because html archives are disabled by default
#Requires:	MHonArc >= 2.4.5
# (gb) 3.0.3-1mdk: added
Requires:	perl-MD5
Requires:	apache
Requires:	openssl >= 0.9.5a
BuildRequires:	perl
BuildRequires:	apache
BuildRequires:	openssl-devel >= 0.9.5a
Prereq:		/usr/sbin/useradd
Prereq:		/usr/sbin/groupadd
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
SYMPA is an electronic mailing list manager. It is used to automate list
management functions such as subscription, moderation and management of 
archives. SYMPA also manages sending of messages to the lists, and 
makes it possible to reduce the load on the system. Provided that you 
have enough memory on your system, Sympa is especially well adapted for big 
lists. For a list with 20 000 subscribers, it takes 5 minutes to send a
message to 90% of subscribers, of course considering that the network is 
available.

Documentation is available under HTML and SGML (source) formats. 

%description -l fr
SYMPA est un gestionnaire de listes lectroniques. Il permet d'automatiser
les fonctions de gestion des listes telles les abonnements, la modration
et la gestion des archives. SYMPA gre galement le renvoi des messages
adresss aux listes et permet de limiter la charge sur le systme. Dans des
configurations avec suffisamment de mmoire, SYMPA est particulirement
adapt aux grandes listes. Avec une liste de 20 000 abonns, il faut 5 
minutes pour envoyer un message  90% des abonns, lorsque le rseau est 
disponible bien videmment.

La documentation est disponible  sous forme HTML. Pour consulter
la premire page veuillez ouvrir la page `doc/HTML/sympa.html' dans votre
outil de navigation prfr. Le source SGML de la doc est aussi disponible
pour gnration du format imprimable de votre choix.


%prep
rm -rf $RPM_BUILD_ROOT

%setup -q
%patch -p1

%build
%serverbuild

# Fix Apache home dir
for f in `find . -type f -exec grep -l "\/home\/httpd" {} \;`; do
  perl -pi -e "s|\/home\/httpd|%{home_a}|" $f
done

# NOTE: the pid/ directory will be created by hand in %install
%make PIDDIR=%{home_s}/pid DIR=%{home_s} sources languages

%install
rm -rf $RPM_BUILD_ROOT

# We can't chown/chgrp here. Fix it later (%files).
for i in ./src/Makefile ./wwsympa/Makefile ./src/etc/sample/Makefile ./Makefile; do
  perl -pi -e "s|chown|/bin/true|" $i
  perl -pi -e "s|chgrp|/bin/true|" $i
done

# Actually chmod the files but not the directory!
perl -pi -e "s|chmod -R 644(.+wws_templates)|chmod 644 \1/*|" ./wwsympa/Makefile

# Patch host name later, at install time
make INITDIR="/etc/rc.d/init.d" HOST=MY_HOST PIDDIR=%{home_s}/pid DIR=%{home_s} DESTDIR=$RPM_BUILD_ROOT install

# Create a directory for Sympa PIDs
mkdir -p $RPM_BUILD_ROOT%{home_s}/pid

# FIXME: where is wwsympa (web interface) installed ??

echo "See README and INSTALL in %{_docdir}/%{name}-%{version}" > $RPM_BUILD_ROOT%{home_s}/README.first

%pre
# Try to add user and group 'sympa'
home_s_pw=`cat /etc/passwd|grep "^sympa:" | sed -e "s=^sympa:[^:]*:[^:]*:[^:]*:[^:]*:\([^:]*\):.*=\1="`
if [ "x${home_s_pw}" = "x" ]; then
  /usr/sbin/groupadd -f sympa 2>/dev/null >/dev/null || :
  /usr/sbin/useradd -u 89 -s /bin/false -d %{home_s} -m -g sympa -c "Sympa mailing list" sympa 2>/dev/null >/dev/null || :
elif [ "${home_s_pw}" != "%{home_s}" ]; then
# (gb) FIXME: should we force the sympa home dir to be %%{home_s} ?
# perl -F: -pi -an -e 'if ($F[0] =~ /sympa/) { s|$F[5]|%{home_s}| }' /etc/passwd
  echo "user sympa already exist with a home different from %{home_s}"
  exit 0
fi

# Setup log facility for Sympa
if [ -f /etc/syslog.conf ] ;then
  if [ `grep -c sympa /etc/syslog.conf` -eq 0 ] ;then
    typeset -i cntlog
    cntlog=0
    while [ `grep -c local${cntlog} /etc/syslog.conf` -gt 0 ];do cntlog=${cntlog}+1;done
    if [ ${cntlog} -le 9 ];then
      echo "# added by %{name}-%{version} rpm $(date)" >> /etc/syslog.conf
      echo "local${cntlog}.*       /var/log/%{name}" >> /etc/syslog.conf
    fi    
  fi
fi

# Try to add some sample entries in /etc/aliases for sympa
# TODO: handle updates from sympa 2.x entries to sympa 3.x entries ?
#       (sympa, listmaster, bounce+*, sympa-request, sympa-owner)
for a_file in /etc/aliases /etc/postfix/aliases; do
  if [ -f ${a_file} ]; then
    if [ `grep -c sympa ${a_file}` -eq 0 ]; then
      cp -f ${a_file} ${a_file}.rpmorig
      echo >> ${a_file}
      echo "# added by %{name}-%{version} rpm " $(date) >> ${a_file}
      if [ `grep -c listmaster ${a_file}` -eq 0 ]; then
        echo "# listmaster:     root" >> ${a_file}
      fi
      echo "# sympa:          \"|%{home_s}/bin/queue 0 sympa\"" >> ${a_file}
      echo "# sympa-request:  listmaster@${HOSTNAME}" >> ${a_file}
      echo "# sympa-owner:    listmaster@${HOSTNAME}" >> ${a_file}
      echo "" >> ${a_file}
#     /usr/bin/newaliases
    fi
  fi
done  

# Eventually, add queue to sendmail security shell
if [ -d /etc/smrsh ]; then
  if [ ! -e /etc/smrsh/queue ]; then
    ln -s %{home_s}/bin/queue /etc/smrsh/queue
  fi
fi

%post
%_post_service sympa

# Try to install some default configuration files if none exists 
if [ ! -f /etc/sympa.conf ] ;then 
   cp -f %{home_s}/sample/sympa.conf /etc
   chown sympa.sympa /etc/sympa.conf
fi
if [ ! -f /etc/wwsympa.conf ];then
   cp -f %{home_s}/sample/wwsympa.conf /etc
   chown sympa.sympa /etc/wwsympa.conf
fi

# Fix syslog variable for the correct subsystem to use in config files
cntlog=`sed -n -e "/^local.*sympa/s|^local\([0-9][0-9]*\)\.\*[ \t]*/var/log/sympa|\1|p" < /etc/syslog.conf`
for conffile in /etc/sympa.conf /etc/wwsympa.conf; do
  perl -pi -e "s|syslog(\s+)LOCAL[0-9]+|syslog\1LOCAL${cntlog}|" $conffile
done

# Setup a correct hostname
perl -pi -e "s|MY_HOST|${HOSTNAME}|g" /etc/sympa.conf /etc/wwsympa.conf

%preun
%_preun_service sympa

%postun
#if [ $1 = 0 ]; then
#  if [ -d "%{home_s}" ]; then
#    rm -rf %{home_s}/*
#  fi
#fi
if [ ! -d "%{home_s}" ]; then
  /usr/sbin/userdel -r sympa
  /usr/sbin/groupdel sympa  
fi
if [ $1 = 0 -a -d /etc/smrsh ]; then
  if [ -L /etc/smrsh/queue ]; then
    rm -f /etc/smrsh/queue
  fi
fi

%files

##
## Documentation
##

%defattr(-,root,root)
%doc INSTALL LICENSE README RELEASE_NOTES
%doc doc/*

%defattr(-,sympa,sympa)
%{home_s}/README.first
%dir %{home_s}/pid

##
## Binaries
##

%defattr(-,sympa,sympa)
%dir %{home_s}/bin

%dir %{home_s}/bin/Marc
%{home_s}/bin/Marc/Search.pm

%dir %{home_s}/bin/etc
%defattr(0644,sympa,sympa)
%{home_s}/bin/etc/create_list.conf
%{home_s}/bin/etc/edit_list.conf
%{home_s}/bin/etc/ca-bundle.crt
%{home_s}/bin/etc/mhonarc-ressources

%defattr(4111,sympa,sympa)
%{home_s}/bin/queue
%{home_s}/bin/bouncequeue

%defattr(0755,sympa,sympa)
%{home_s}/bin/wwsympa.fcgi

%defattr(0644,sympa,sympa)
%{home_s}/bin/mime.types

%defattr(0644,sympa,sympa)
%{home_s}/bin/create_db.Pg
%{home_s}/bin/create_db.mysql
%{home_s}/bin/create_db.Oracle
%{home_s}/bin/create_db.Sybase

%defattr(0755,sympa,sympa)
%{home_s}/bin/sympa.pl
%{home_s}/bin/bounced.pl
%{home_s}/bin/archived.pl
%{home_s}/bin/load_subscribers.pl
%{home_s}/bin/arc2webarc.pl
%{home_s}/bin/testldap.pl
%{home_s}/bin/p12topem.pl

%defattr(0644,sympa,sympa)
%{home_s}/bin/msg.pl
%{home_s}/bin/tools.pl
%{home_s}/bin/parser.pl
%{home_s}/bin/wws-lib.pl
%{home_s}/bin/cookie-lib.pl
%{home_s}/bin/bounce-lib.pl

%defattr(0644,sympa,sympa)
%{home_s}/bin/Archive.pm
%{home_s}/bin/Commands.pm
%{home_s}/bin/Conf.pm
%{home_s}/bin/Language.pm
%{home_s}/bin/List.pm
%{home_s}/bin/Log.pm
%{home_s}/bin/mail.pm
%{home_s}/bin/smtp.pm
%{home_s}/bin/Version.pm
%{home_s}/bin/Marc.pm

##
## Scenarios
##

%defattr(-,sympa,sympa)
%dir %{home_s}/bin/etc/scenari

%{home_s}/bin/etc/scenari/access_web_archive.closed
%{home_s}/bin/etc/scenari/access_web_archive.intranet
%{home_s}/bin/etc/scenari/access_web_archive.listmaster
%{home_s}/bin/etc/scenari/access_web_archive.owner
%{home_s}/bin/etc/scenari/access_web_archive.private
%{home_s}/bin/etc/scenari/access_web_archive.public
%{home_s}/bin/etc/scenari/add.auth
%{home_s}/bin/etc/scenari/add.closed
%{home_s}/bin/etc/scenari/add.default
%{home_s}/bin/etc/scenari/add.owner
%{home_s}/bin/etc/scenari/add.owner_notify
%{home_s}/bin/etc/scenari/create_list.default
%{home_s}/bin/etc/scenari/create_list.intranet
%{home_s}/bin/etc/scenari/create_list.listmaster
%{home_s}/bin/etc/scenari/d_edit.default
%{home_s}/bin/etc/scenari/d_edit.owner
%{home_s}/bin/etc/scenari/d_edit.private
%{home_s}/bin/etc/scenari/d_edit.public
%{home_s}/bin/etc/scenari/d_read.default
%{home_s}/bin/etc/scenari/d_read.owner
%{home_s}/bin/etc/scenari/d_read.private
%{home_s}/bin/etc/scenari/d_read.public
%{home_s}/bin/etc/scenari/del.auth
%{home_s}/bin/etc/scenari/del.closed
%{home_s}/bin/etc/scenari/del.default
%{home_s}/bin/etc/scenari/del.owner
%{home_s}/bin/etc/scenari/del.owner_notify
%{home_s}/bin/etc/scenari/edit_list.closed
%{home_s}/bin/etc/scenari/edit_list.owner
%{home_s}/bin/etc/scenari/global_remind.listmaster
%{home_s}/bin/etc/scenari/info.default
%{home_s}/bin/etc/scenari/info.open
%{home_s}/bin/etc/scenari/info.private
%{home_s}/bin/etc/scenari/invite.closed
%{home_s}/bin/etc/scenari/invite.default
%{home_s}/bin/etc/scenari/invite.owner
%{home_s}/bin/etc/scenari/invite.private
%{home_s}/bin/etc/scenari/invite.public
%{home_s}/bin/etc/scenari/remind.default
%{home_s}/bin/etc/scenari/remind.listmaster
%{home_s}/bin/etc/scenari/remind.owner
%{home_s}/bin/etc/scenari/review.closed
%{home_s}/bin/etc/scenari/review.default
%{home_s}/bin/etc/scenari/review.listmaster
%{home_s}/bin/etc/scenari/review.open
%{home_s}/bin/etc/scenari/review.owner
%{home_s}/bin/etc/scenari/review.private
%{home_s}/bin/etc/scenari/review.public
%{home_s}/bin/etc/scenari/send.closed
%{home_s}/bin/etc/scenari/send.default
%{home_s}/bin/etc/scenari/send.editor
%{home_s}/bin/etc/scenari/send.editorkey
%{home_s}/bin/etc/scenari/send.editorkeyonly
%{home_s}/bin/etc/scenari/send.editorkeyonlyauth
%{home_s}/bin/etc/scenari/send.intranet
%{home_s}/bin/etc/scenari/send.intranetorprivate
%{home_s}/bin/etc/scenari/send.newsletter
%{home_s}/bin/etc/scenari/send.newsletterkeyonly
%{home_s}/bin/etc/scenari/send.private
%{home_s}/bin/etc/scenari/send.private_smime
%{home_s}/bin/etc/scenari/send.privateandeditorkey
%{home_s}/bin/etc/scenari/send.privateandnomultipartoreditorkey
%{home_s}/bin/etc/scenari/send.privatekey
%{home_s}/bin/etc/scenari/send.privatekeyandeditorkeyonly
%{home_s}/bin/etc/scenari/send.privateoreditorkey
%{home_s}/bin/etc/scenari/send.privateorpublickey
%{home_s}/bin/etc/scenari/send.public
%{home_s}/bin/etc/scenari/send.public_nobcc
%{home_s}/bin/etc/scenari/send.publickey
%{home_s}/bin/etc/scenari/send.publicnomultipart
%{home_s}/bin/etc/scenari/subscribe.auth
%{home_s}/bin/etc/scenari/subscribe.auth_notify
%{home_s}/bin/etc/scenari/subscribe.auth_owner
%{home_s}/bin/etc/scenari/subscribe.closed
%{home_s}/bin/etc/scenari/subscribe.default
%{home_s}/bin/etc/scenari/subscribe.intranet
%{home_s}/bin/etc/scenari/subscribe.intranetorowner
%{home_s}/bin/etc/scenari/subscribe.open
%{home_s}/bin/etc/scenari/subscribe.open_notify
%{home_s}/bin/etc/scenari/subscribe.open_quiet
%{home_s}/bin/etc/scenari/subscribe.owner
%{home_s}/bin/etc/scenari/subscribe.smime
%{home_s}/bin/etc/scenari/subscribe.smimeorowner
%{home_s}/bin/etc/scenari/topics_visibility.conceal
%{home_s}/bin/etc/scenari/topics_visibility.default
%{home_s}/bin/etc/scenari/topics_visibility.noconceal
%{home_s}/bin/etc/scenari/unsubscribe.auth
%{home_s}/bin/etc/scenari/unsubscribe.auth_notify
%{home_s}/bin/etc/scenari/unsubscribe.closed
%{home_s}/bin/etc/scenari/unsubscribe.default
%{home_s}/bin/etc/scenari/unsubscribe.open
%{home_s}/bin/etc/scenari/unsubscribe.open_notify
%{home_s}/bin/etc/scenari/unsubscribe.owner
%{home_s}/bin/etc/scenari/visibility.conceal
%{home_s}/bin/etc/scenari/visibility.default
%{home_s}/bin/etc/scenari/visibility.intranet
%{home_s}/bin/etc/scenari/visibility.noconceal
%{home_s}/bin/etc/scenari/visibility.private
%{home_s}/bin/etc/scenari/visibility.public
%{home_s}/bin/etc/scenari/visibility.secret

##
## Templates
##

%defattr(-,sympa,sympa)
%dir %{home_s}/bin/etc/create_list_templates

%dir %{home_s}/bin/etc/create_list_templates/discussion_list
%{home_s}/bin/etc/create_list_templates/discussion_list/*.tpl
%{home_s}/bin/etc/create_list_templates/discussion_list/comment

%dir %{home_s}/bin/etc/create_list_templates/hotline
%{home_s}/bin/etc/create_list_templates/hotline/*.tpl

%dir %{home_s}/bin/etc/create_list_templates/intranet_list
%{home_s}/bin/etc/create_list_templates/intranet_list/*.tpl

%dir %{home_s}/bin/etc/create_list_templates/news-letter
%{home_s}/bin/etc/create_list_templates/news-letter/*.tpl
%{home_s}/bin/etc/create_list_templates/news-letter/comment

%dir %{home_s}/bin/etc/create_list_templates/private_working_group
%{home_s}/bin/etc/create_list_templates/private_working_group/*.tpl

%dir %{home_s}/bin/etc/create_list_templates/public_web_forum
%{home_s}/bin/etc/create_list_templates/public_web_forum/*.tpl

%dir %{home_s}/bin/etc/templates
%{home_s}/bin/etc/templates/*.tpl

%dir %{home_s}/bin/etc/wws_templates
%{home_s}/bin/etc/wws_templates/*.tpl
%{home_s}/bin/etc/wws_templates/*.tpl2

##
## Locales
##

%defattr(-,sympa,sympa)
%dir %{home_s}/nls

%{home_s}/nls/fr.cat
%{home_s}/nls/us.cat
%{home_s}/nls/es.cat
%{home_s}/nls/de.cat
%{home_s}/nls/it.cat
%{home_s}/nls/cn-gb.cat
%{home_s}/nls/cn-big5.cat
%{home_s}/nls/fi.cat

##
## Sample config files
##

%defattr(-,sympa,sympa)
%dir %{home_s}/sample

%{home_s}/sample/README
%{home_s}/sample/config.digest
%{home_s}/sample/config.include
%{home_s}/sample/config.moderation
%{home_s}/sample/config.privateorpublickey
%{home_s}/sample/config.public
%{home_s}/sample/topics.conf
%{home_s}/sample/sympa.conf
%{home_s}/sample/wwsympa.conf

##
## Working directory
##

%defattr(-,sympa,sympa)
%dir %{home_s}/expl

%dir %{home_s}/expl/test
%{home_s}/expl/test/config
%{home_s}/expl/test/info
%{home_s}/expl/test/message.footer
%{home_s}/expl/test/welcome.tpl

##
## Site configuration directory
##

%defattr(-,sympa,sympa)
%dir %{home_s}/etc
%dir %{home_s}/etc/create_list_templates
%dir %{home_s}/etc/templates
%dir %{home_s}/etc/wws_templates
%dir %{home_s}/etc/scenari

##
## Spool directories
##

%defattr(0755,sympa,sympa)
%dir %{home_s}/spool
%dir %{home_s}/spool/msg
%dir %{home_s}/spool/digest
%dir %{home_s}/spool/moderation
%dir %{home_s}/spool/expire
%dir %{home_s}/spool/auth
%dir %{home_s}/spool/outgoing
%dir %{home_s}/spool/tmp

##
## Icons for Apache
##

%defattr(-,apache,apache)
%dir %{home_a}/icons
%{home_a}/icons/*.gif

##
## Init scripts
##

%defattr(0755,root,root)
%config(noreplace) /etc/rc.d/init.d/sympa

##
## Global config files
##

%defattr(0600,sympa,sympa)
%config(noreplace) /etc/sympa.conf
%config(noreplace) /etc/wwsympa.conf

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Fri Apr 13 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.0.3-1mdk
- updated to stable version 3.0.3
- sanitized specfile (s/Copyright/License, server macros, Requires, etc.)
- sanitized build process: DESTDIR is set to %{home_s}
- added directory in sympa home for pids
- added missing variables when generating config files (patch0)
- fixed file to chown (wwsympa.conf) in %%post section
- fixed syslog variable in /etc/[ww]sympa.conf
- removed patch1: log_socket_type=inet, openssl path are set correctly
- removed patch2: use_fast_cgi=0, no html archives (mhonarc path unset)

* Wed Oct 11 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.7.3-7mdk
- Make something smarter than exit 1 when doing an upgrade and moving
  the sympa files.

* Fri Oct  6 2000 Denis Havlik <denis@mandrakesoft.com> 2.7.3-6mdk
- changed home-dir to /var/lib/sympa, fixed config. files
- fixed licence (GPL now)

* Wed Aug 30 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 2.7.3-5mdk
- requires apache because of wwsympa.
- buildrequires apache to fix building for machines without apache (sic).

* Fri Aug 18 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 2.7.3-4mdk
- rebuild to enable openssl.
- add requires and buildrequires for {openssl,openssl-devel}
- copy the wwsympa configuration file on postun if none is present in /etc.

* Thu Aug 17 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 2.7.3-3mdk
- rebuild to fix some more annoying bugs.

* Mon Aug 14 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 2.7.3-2mdk
- rebuild for sympa disaster

* Tue Aug 01 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 2.7.3-1mdk
- big shiny new version and got this ugly fucking piece of shit to package
- rebuild for BM

* Tue Apr 18 2000 Jerome Dumonteil <jd@mandrakesoft.com>
- change group
* Fri Mar 31 2000 Jerome Dumonteil <jd@mandrakesoft.com>
- change group
- modif postun
* Wed Dec 29 1999 Jerome Dumonteil <jd@mandrakesoft.com>
- version 2.4
* Fri Dec 17 1999 Jerome Dumonteil <jd@mandrakesoft.com>
- added link /etc/smrsh/queue
- added link for /home/sympa/expl/helpfile
* Thu Dec 09 1999 Jerome Dumonteil <jd@mandrakesoft.com>
- remove backup files from sources
- strip binary
* Mon Dec  6 1999 Jerome Dumonteil <jd@mandrakesoft.com>
- added prereq info.
- little cleanup.
* Fri Dec  3 1999 Jerome Dumonteil <jd@mandrakesoft.com>
- first version of rpm.
